/*******************************************************************************
* File Name: iPark.h  
* Version 2.0
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_iPark_H) /* Pins iPark_H */
#define CY_PINS_iPark_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "iPark_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    iPark_Write(uint8 value) ;
void    iPark_SetDriveMode(uint8 mode) ;
uint8   iPark_ReadDataReg(void) ;
uint8   iPark_Read(void) ;
uint8   iPark_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define iPark_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define iPark_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define iPark_DM_RES_UP          PIN_DM_RES_UP
#define iPark_DM_RES_DWN         PIN_DM_RES_DWN
#define iPark_DM_OD_LO           PIN_DM_OD_LO
#define iPark_DM_OD_HI           PIN_DM_OD_HI
#define iPark_DM_STRONG          PIN_DM_STRONG
#define iPark_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define iPark_MASK               iPark__MASK
#define iPark_SHIFT              iPark__SHIFT
#define iPark_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define iPark_PS                     (* (reg8 *) iPark__PS)
/* Data Register */
#define iPark_DR                     (* (reg8 *) iPark__DR)
/* Port Number */
#define iPark_PRT_NUM                (* (reg8 *) iPark__PRT) 
/* Connect to Analog Globals */                                                  
#define iPark_AG                     (* (reg8 *) iPark__AG)                       
/* Analog MUX bux enable */
#define iPark_AMUX                   (* (reg8 *) iPark__AMUX) 
/* Bidirectional Enable */                                                        
#define iPark_BIE                    (* (reg8 *) iPark__BIE)
/* Bit-mask for Aliased Register Access */
#define iPark_BIT_MASK               (* (reg8 *) iPark__BIT_MASK)
/* Bypass Enable */
#define iPark_BYP                    (* (reg8 *) iPark__BYP)
/* Port wide control signals */                                                   
#define iPark_CTL                    (* (reg8 *) iPark__CTL)
/* Drive Modes */
#define iPark_DM0                    (* (reg8 *) iPark__DM0) 
#define iPark_DM1                    (* (reg8 *) iPark__DM1)
#define iPark_DM2                    (* (reg8 *) iPark__DM2) 
/* Input Buffer Disable Override */
#define iPark_INP_DIS                (* (reg8 *) iPark__INP_DIS)
/* LCD Common or Segment Drive */
#define iPark_LCD_COM_SEG            (* (reg8 *) iPark__LCD_COM_SEG)
/* Enable Segment LCD */
#define iPark_LCD_EN                 (* (reg8 *) iPark__LCD_EN)
/* Slew Rate Control */
#define iPark_SLW                    (* (reg8 *) iPark__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define iPark_PRTDSI__CAPS_SEL       (* (reg8 *) iPark__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define iPark_PRTDSI__DBL_SYNC_IN    (* (reg8 *) iPark__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define iPark_PRTDSI__OE_SEL0        (* (reg8 *) iPark__PRTDSI__OE_SEL0) 
#define iPark_PRTDSI__OE_SEL1        (* (reg8 *) iPark__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define iPark_PRTDSI__OUT_SEL0       (* (reg8 *) iPark__PRTDSI__OUT_SEL0) 
#define iPark_PRTDSI__OUT_SEL1       (* (reg8 *) iPark__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define iPark_PRTDSI__SYNC_OUT       (* (reg8 *) iPark__PRTDSI__SYNC_OUT) 


#if defined(iPark__INTSTAT)  /* Interrupt Registers */

    #define iPark_INTSTAT                (* (reg8 *) iPark__INTSTAT)
    #define iPark_SNAP                   (* (reg8 *) iPark__SNAP)

#endif /* Interrupt Registers */

#endif /* End Pins iPark_H */


/* [] END OF FILE */
